﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Diagnostics;

namespace testGenerateEntity
{
    class Program
    {
        static void Main(string[] args)
        {
            Stopwatch sw = new Stopwatch();
            int rows = 100000;
            sw.Restart();
            DataTable dt = DataTableData.GetCustomer(rows);
            sw.Stop();
            Console.WriteLine("{0} ,create entity ojects, total {1} rows, time: {2}ms", "Build".PadRight(12, ' '), rows, sw.ElapsedMilliseconds.ToString());

            sw.Restart();
            List<Customer> cusAssign = new ToEntityByAssign().GetEntity(dt);
            sw.Stop();
            Console.WriteLine("{0} ,generate list of entity, total {1} rows, time: {2}ms", "Assign".PadRight(12, ' '), rows, sw.ElapsedMilliseconds.ToString());
            //Console.WriteLine("The fifth element is: {0}",cusAssign[4].Name+" , "+ cusAssign[4].Age+" , "+cusAssign[4].Sex);

            sw.Restart();
            List<Customer> cusEmit = ToEntityByEmit.GetList<Customer>(dt);
            sw.Stop();
            Console.WriteLine("{0} ,generate list of entity, total {1} rows, time: {2}ms", "Emit".PadRight(12, ' '), rows, sw.ElapsedMilliseconds.ToString());
            //Console.WriteLine("The fifth element is: {0}", cusEmit[4].Name + " , " + cusEmit[4].Age + " , " + cusEmit[4].Sex);

            sw.Restart();
            List<Customer> cusExpress = ToEntityByExpression.GetEntity<Customer>(dt);
            sw.Stop();
            Console.WriteLine("{0} ,generate list of entity, total {1} rows, time: {2}ms", "Expression".PadRight(12, ' '), rows, sw.ElapsedMilliseconds.ToString());
            //Console.WriteLine("The fifth element is: {0}", cusExpress[4].Name + " , " + cusExpress[4].Age + " , " + cusExpress[4].Sex);

            sw.Restart();
            List<Customer> cusReflection = new ToEntityByReflection<Customer>().GetEntity(dt);
            sw.Stop();
            Console.WriteLine("{0} ,generate list of entity, total {1} rows, time: {2}ms", "Reflection".PadRight(12, ' '), rows, sw.ElapsedMilliseconds.ToString());
            //Console.WriteLine("The fifth element is: {0}", cusReflection[4].Name + " , " + cusReflection[4].Age + " , " + cusReflection[4].Sex);

            sw.Restart();
            List<Customer> cusDelegate = new ToEntityByDelegate<Customer>().GetEntity(dt);
            sw.Stop();
            Console.WriteLine("{0} ,generate list of entity, total {1} rows, time: {2}ms", "Delegate".PadRight(12, ' '), rows, sw.ElapsedMilliseconds.ToString());
            //Console.WriteLine("The fifth element is: {0}", cusDelegate[4].Name + " , " + cusDelegate[4].Age + " , " + cusDelegate[4].Sex);


            Console.WriteLine();
            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }
    }
}
